/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: Patrick Boenzli
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LOAD

#include "new_resource_manager.h"
#include "debug.h"

#include <algorithm>
#include <assert.h>

ObjectListDefinition(NewResourceManager);

/**
 * @brief standard constructor
*/
NewResourceManager::NewResourceManager ()
{
  this->registerObject(this, NewResourceManager::_objectList);
  this->setName("NewResourceManager");

  //this->dataDir = "./";
  this->tryDataDir("./data");
}

//! Singleton Reference to the NewResourceManager
NewResourceManager* NewResourceManager::singletonRef = NULL;

/**
 * @brief standard destructor
*/
NewResourceManager::~NewResourceManager ()
{
  // deleting the Resources-List
  //this->unloadAllByPriority(RP_GAME);

//   if (!this->resourceList.empty())
//     PRINTF(1)("Not removed all Resources, since there are still %d resources registered\n", this->resourceList.size());

  NewResourceManager::singletonRef = NULL;
}



/**
 * @brief outputs debug information about the NewResourceManager
 */
void NewResourceManager::debug() const
{
  PRINT(0)("=RM===================================\n");
  PRINT(0)("= RESOURCE-MANAGER DEBUG INFORMATION =\n");
  PRINT(0)("======================================\n");

  PRINT(0)("==================================RM==\n");
}
