/*!
 * @file new_resource_manager.h
 */

#ifndef _NEW_RESOURCE_MANAGER_H
#define _NEW_RESOURCE_MANAGER_H

#include "resource.h"
#include "filesys/file.h"
#include "filesys/directory.h"

class NewResourceManager : public BaseObject
{
  ObjectListDeclaration(NewResourceManager);
public:
  virtual ~NewResourceManager();
  /** @returns a Pointer to the only object of this Class */
  inline static NewResourceManager* getInstance() { if (!singletonRef) singletonRef = new NewResourceManager();  return singletonRef; };

  bool tryDataDir(const std::string& dataDir);
  bool verifyDataDir(const std::string& fileInside);

  bool unloadAllByPriority();

  void debug() const;

  // utility functions for handling files in and around the data-directory
  static std::string getFullName(const std::string& fileName);
  static bool isInDataDir(const std::string& fileName);

private:
  NewResourceManager();

private:
  static NewResourceManager*    singletonRef;       //!< singleton Reference

};

#endif /* _RESOURCE_MANAGER_H */
